<?php

namespace App;

use Nette\Application\UI,
Nette\ComponentModel\IContainer,
Nette\Utils\Html;

class DefaultForm extends UI\Form
{
	public function __construct(IContainer $parent = NULL, $name = NULL)
	{
		parent::__construct($parent, $name);
		$this->layouts = array(
				'dl' => array(
					Html::el('dl')->class('form'), 
					null, 'dt', 'dd'
				),
				'inline' => array(null, null, null, null),
			);
		$this->setLayout('dl');
	}
	public $layouts;

	public $jsHelper = null;
	
	public function setLayout($layoutName) {
		$renderer = $this->getRenderer();
		list($controls, $pair, $label, $control) = $this->layouts[$layoutName];
		$renderer->wrappers['controls']['container'] = $controls;
		$renderer->wrappers['pair']['container'] = $pair;
		$renderer->wrappers['label']['container'] = $label;
		$renderer->wrappers['control']['container'] = $control;
	}
	
	public function sectionDefaults($section, $values) {
		$defaults = array();
		foreach($values as $k => $v) {
			$defaults[$section.'_'.$k] = $v;
		}
		$this->defaults = $defaults;		
	}
	public function sectionValues($section) {
		$res = array();
		$pos = strlen($section) + 1;
		foreach($this->values as $k => $v) {
			if (\Nette\Utils\Strings::startsWith($k, $section.'_')) {
				$res[substr($k, $pos)] = $v;
			}
		}
		Utils::varbar($res, 'arr');
		Utils::varbar(\Nette\ArrayHash::from($res), 'ha');
		return \Nette\ArrayHash::from($res);
	}
	public function renderJsHelper() {
		if ($this->jsHelper) {
			/*\Murdej\PageHead::addJsFile('/js/formHelper-'.$this->jsHelper.'.js');
			\Murdej\PageHead::addOnLoad('new FormHelper'.\Nette\Utils\Strings::firstUpper($this->jsHelper).'(document.getElementById("'.$this->elementPrototype->id.'"))');*/
			echo '<script type="text/javascript" src="/js/formHelper'.\Nette\Utils\Strings::firstUpper($this->jsHelper).'.js"></script>'
				.'<script type="text/javascript">$(function() { new FormHelper'.\Nette\Utils\Strings::firstUpper($this->jsHelper).'(document.getElementById("'.$this->elementPrototype->id.'")) }); </script>';
		}
	}
	public function render(...$args) : void {
		$this->renderJsHelper();
		parent::render(...$args);
	}
}
