<?php

namespace App;

/**
 * @dbTable
 * @property int $id (autoIncrement)
 * @property Product $product (fk)
 * @property Prepaid $prepaid (fk,?)
 * @property PackageProduct $packageProduct (fk,?)
 * @property Directpaid $directpaid (fk,?)
 * @property ?decimal $priceDirectpaid
 * @property ?decimal $priceCachless
 * @property ?decimal $priceCreditCA
 * @property ?decimal $priceCreditCL
 * @property ?decimal $priceCreditExistsCA
 * @property ?decimal $priceCreditExistsCL
 * @property ?decimal $productAmount
 * @property int $utSell
 * @property User $createUser (fk)
 * @property User $cancelUser (fk,?)
 * @property int $cancelUt (?)
 * @property string $cancelNote (?)
 * @property string $customName (?)
 * @property bool $deleted
 * @property decimal $bonusCredit (?)
 * @property ReceiptTaxItem $receiptTaxItem (fk)
 * @related ProductSellNote $notes
**/
class ProductSell extends BaseModel
{
	// Stornuje polozku
	public function cancel($note) 
	{
		if (!$this->canceled) {
			// Oznac jako storno
			$this->cancelUserId = Glob::currentAccountId();
			$this->cancelUt = time();
			$this->cancelNote = $note;
			$this->save();
			// Vrat kredit
			if ($this->priceCredit > 0) {
				// Glob::varbar($this->priceCredit);
				$pp = $this->prepaid;
				// Glob::varbar($pp->creditLeft);
                $pp->creditCLLeft += $this->priceCreditCL;
                $pp->creditCALeft += $this->priceCreditCA;

				$pp->save();
			}
			// Vrat produkt
			if ($this->productAmount) {
				$ppp = $this->prepaidPackageProduct;
				// Glob::varbar($ppp);
				$ppp->amountLeft += $this->productAmount;
				$ppp->save();
			}
			// znovu naskladni pokud je skladová položka
			$osch = StockChange::getBy(['productSellId' => $this->id]);
			if ($osch)
			{
				$sch = new StockChange();
				$sch->fromArray($osch->toArray());
				$sch->utChange = $this->cancelUt;
				$sch->changeAmount = -$sch->changeAmount;
				$sch->save();
			}
			//foo();
		}
	}
	
	public function getPrepaidPackageProduct() 
	{
		return PrepaidPackageProduct::getBy([
			'prepaidId' => $this->prepaidId,
			'packageProductId' => $this->packageProductId,
		]);
	}
	
	public function isCanceled() 
	{
		return $this->cancelUt !== null;
	}
	
	/* public function getProduct() {
		return $this->ref('product', 'productId');
	} */
	/*public function getCreateUser() {
		return $this->ref('user', 'createUserId');
	}
	public function getCancelUser() {
		return $this->ref('user', 'cancelUserId');
	}
	public function getNotes() {
		// die('ddd');
		return $this->related('productSellNote');
	}*/
	public function getDisplayName() 
	{
        $ret = $this->product->name;
        if ($this->product->code == 'creditChange') {
            $ret .= ' ' . $this->priceDirectpaid;
            if ($this->bonusCredit) $ret .= ' + ' . $this->bonusCredit;
        }
        return $ret;
	}
	
	public function addNote(string $note) : ProductSellNote
	{
		$oNote = new ProductSellNote();
		$oNote->productSellId = $this->id;
		$oNote->note = $note;
		$oNote->utAdd = time();
		$oNote->userId = Glob::currentAccountId();

		$oNote->save();
		
		return $oNote;
		/* $this->context->productSellNotes->insert(array(
			'productSellId' => $this->id,
			'note' => $note,
			'utAdd' => time(),
			'userId' => $this->context->user->id
		)); */
	}

	public function getPriceCredit()
	{
		return $this->priceCreditCA + $this->priceCreditCL;
	}

}